"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RedshiftQuery = void 0;
const PostgresQuery_1 = require("./PostgresQuery");
class RedshiftQuery extends PostgresQuery_1.PostgresQuery {
    seriesSql(timeDimension) {
        const values = timeDimension.timeSeries().map(([from, to]) => `select '${from}' f, '${to}' t`).join(' UNION ALL ');
        return `SELECT dates.f::timestamp date_from, dates.t::timestamp date_to FROM (${values}) dates`;
    }
    nowTimestampSql() {
        return 'GETDATE()';
    }
    sqlTemplates() {
        const templates = super.sqlTemplates();
        templates.functions.DLOG10 = 'LOG(10, {{ args_concat }})';
        templates.functions.DATEDIFF = 'DATEDIFF({{ date_part }}, {{ args[1] }}, {{ args[2] }})';
        delete templates.functions.COVAR_POP;
        delete templates.functions.COVAR_SAMP;
        delete templates.window_frame_types.range;
        delete templates.window_frame_types.groups;
        templates.types.binary = 'VARBINARY';
        return templates;
    }
}
exports.RedshiftQuery = RedshiftQuery;
//# sourceMappingURL=RedshiftQuery.js.map